package com.nisum.ecomcustomer.config.mongodb;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.mongodb.config.AbstractMongoClientConfiguration;
import org.springframework.data.mongodb.core.convert.DefaultMongoTypeMapper;

import static com.nisum.ecomcustomer.config.mongodb.CustomMongoConverters.*;
import static com.nisum.ecomcustomer.config.mongodb.CustomMongoConverters.CustomerTypeToIntegerConverter;
import static com.nisum.ecomcustomer.config.mongodb.CustomMongoConverters.IntegerToCustomerTypeConverter;
import static org.springframework.data.mongodb.core.convert.MongoCustomConversions.MongoConverterConfigurationAdapter;

@Configuration
public class MongoConfig extends AbstractMongoClientConfiguration {

    @Value("${spring.data.mongodb.database}")
    private String databaseName;

    @Override
    protected String getDatabaseName() {
        return databaseName;
    }

//TODO - know about the good practices.

//    @Bean
//    @Override
//    public MappingMongoConverter mappingMongoConverter(MongoDatabaseFactory databaseFactory, MongoCustomConversions customConversions, MongoMappingContext mappingContext) {
//        MappingMongoConverter mmc = super.mappingMongoConverter(databaseFactory, customConversions, mappingContext);
//        mmc.setTypeMapper(getTypeMapper());
//        return mmc;
//    }
//
//    @Bean
//    public MongoTypeMapper getTypeMapper() {
//        return new CustomMongoTypeMapper();
//    }

    @Override
    protected void configureConverters(MongoConverterConfigurationAdapter adapter) {
        adapter.registerConverter(new CustomerTypeToIntegerConverter());
        adapter.registerConverter(new IntegerToCustomerTypeConverter());
        adapter.registerConverter(new AddressTypeToStringConverter());
        adapter.registerConverter(new StringToAddressTypeConverter());
    }
}

class CustomMongoTypeMapper extends DefaultMongoTypeMapper {

    CustomMongoTypeMapper() {
        super(null);
    }

}



